/* Normal Map Stuff */
/* By: Flyguy */
/* With help from http://stackoverflow.com/q/5281261 */

// fancified a bit by psonice

// slimified a bit by kabuto
 
#ifdef GL_ES
precision mediump float;
#endif

#define PI 3.141592 

uniform float HM_time;
uniform float HM_x;
uniform float HM_y;
uniform float HM_z;
uniform float HM_speed;
uniform vec2 HM_resolution;

float heightmap(vec2 position)
{
	float height = 0.0;
	float f = .002;
	vec2 timevec = HM_time * vec2(.1, .13);
	float g = sqrt(1.25) + .5;
	position *= f;
	float c = cos(2. * PI * g);
	float s = sin(2. * PI * g);
	mat2 matcs = mat2(c, s, -s, c) * g;
	for (int i = 0; i < 13; i++) 
	{
		vec2 v = fract(position + timevec) - .5;
		float dots = max(0., .13 - dot(v,v));
		dots = dots * dots * dots / f * 8.;
		height += dots * dots * 2.;
		f *= g;
		position = position * matcs;
	}
	
	return sqrt(height);
}
	
float n1,n2,n3,n4;
vec2 size = vec2(-0.4,0.0);

void main( void ) 
{
	vec2 pos = gl_FragCoord.xy;

	vec2 posRelativ = vec2(HM_x * 10.0, HM_y * 10.0); // iResolution;
	posRelativ.y = HM_resolution.y - posRelativ.y; 
	posRelativ = posRelativ / HM_resolution;

	n1 = heightmap( vec2(pos.x, pos.y - 1.0));
	n2 = heightmap( vec2(pos.x - 1.0, pos.y));
	n3 = heightmap( vec2(pos.x + 1.0, pos.y));
	n4 = heightmap( vec2(pos.x, pos.y + 1.0));
	
	vec3 p2m = vec3(-(( pos / HM_resolution) - posRelativ ) * HM_resolution, HM_resolution.x * .2);	

	vec3 normal = normalize( vec3(n2 - n3, n1 - n4, 0.4));
	
	float color = dot(normal, normalize(p2m)) * 1.;
	vec3 colorvec = vec3(pow(color, 6.), pow(color, 5.), pow(color, 2.9));
	
	float brightness = 1./sqrt(1.+pow( distance( posRelativ * HM_resolution, pos) / HM_resolution.x * 8., 2.));
	
	gl_FragColor = vec4( colorvec + brightness * vec3(2.1, 0.9, 0.7) - 1.0 + vec3(0.0, 0.1, 0.52), 1.0 );
}