
uniform float HM_time;
uniform float HM_x;
uniform float HM_y;
uniform float HM_z;
uniform float HM_speed;
uniform vec2 HM_resolution;

// edit of http://glslsandbox.com/e#18752.0

float gTime = HM_time * 0.5;

void main( void )
{
	float f = 3.0;
	float g = 3.0;
	vec2 pos = vec2(HM_x, HM_y);
	
	pos.x = sin(gTime * .3) * sin( gTime * .17) * 1. + sin(gTime * .3);
	pos.y = (1.0 - cos(gTime * .632)) * sin(gTime * .131) * 1.0 + cos(gTime * .3);
	pos = (pos + 1.0) * HM_resolution;

	vec2 z = (( -HM_resolution + 2.0 * gl_FragCoord.xy) / HM_resolution.y);
	vec2 p = (( -HM_resolution + 2.0 + pos) / HM_resolution.y) * (HM_speed / 100.0);
	 
	for( int i = 0; i < 25; i++) 
	{
		float d = dot(z, z);
		z = (vec2( z.x, -z.y ) / d) + p * (HM_z / 100.0); 
		z.x =  1.0 - abs(z.x);
		f = max(f - d, (dot(z - p, z - p) ));
		g = min(g * d, sin(dot(z + p, z + p)) + 1.0);
	}

	f = abs(-log(f) / 3.5);
	g = abs(-log(g) / 8.0);
	gl_FragColor = vec4(min(vec3(g, g * f, f), 1.0), 1.0);
}